(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/operators'), require('@angular/common'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ngx-highlightjs', ['exports', '@angular/core', 'rxjs/operators', '@angular/common', 'rxjs'], factory) :
    (global = global || self, factory(global['ngx-highlightjs'] = {}, global.ng.core, global.rxjs.operators, global.ng.common, global.rxjs));
}(this, (function (exports, core, operators, common, rxjs) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function HighlightLibrary() { }
    if (false) {
        /**
         * Core highlighting function.
         * @param {?} name Accepts a language name, or an alias
         * @param {?} value A string with the code to highlight.
         * @param {?} ignore_illegals When present and evaluates to a true value, forces highlighting to finish
         * even in case of detecting illegal syntax for the language instead of throwing an exception.
         * @param {?=} continuation An optional mode stack representing unfinished parsing.
         * When present, the function will restart parsing from this state instead of initializing a new one
         * @return {?}
         */
        HighlightLibrary.prototype.highlight = function (name, value, ignore_illegals, continuation) { };
        /**
         * Highlighting with language detection.
         * @param {?} value Accepts a string with the code to highlight
         * @param {?} languageSubset An optional array of language names and aliases restricting detection to only those languages.
         * The subset can also be set with configure, but the local parameter overrides the option if set.
         * @return {?}
         */
        HighlightLibrary.prototype.highlightAuto = function (value, languageSubset) { };
        /**
         * Post-processing of the highlighted markup.
         * Currently consists of replacing indentation TAB characters and using <br> tags instead of new-line characters.
         * Options are set globally with configure.
         * @param {?} value Accepts a string with the highlighted markup
         * @return {?}
         */
        HighlightLibrary.prototype.fixMarkup = function (value) { };
        /**
         * Applies highlighting to a DOM node containing code.
         * The function uses language detection by default but you can specify the language in the class attribute of the DOM node.
         * See the class reference for all available language names and aliases.
         * @param {?} block The element to apply highlight on.
         * @return {?}
         */
        HighlightLibrary.prototype.highlightBlock = function (block) { };
        /**
         * Configures global options:
         * @param {?} config HighlightJs configuration argument
         * @return {?}
         */
        HighlightLibrary.prototype.configure = function (config) { };
        /**
         * Applies highlighting to all <pre><code>..</code></pre> blocks on a page.
         * @return {?}
         */
        HighlightLibrary.prototype.initHighlighting = function () { };
        /**
         * Adds new language to the library under the specified name. Used mostly internally.
         * @param {?} name A string with the name of the language being registered
         * @param {?} language A function that returns an object which represents the language definition.
         * The function is passed the hljs object to be able to use common regular expressions defined within it.
         * @return {?}
         */
        HighlightLibrary.prototype.registerLanguage = function (name, language) { };
        /**
         * @return {?} The languages names list.
         */
        HighlightLibrary.prototype.listLanguages = function () { };
        /**
         * Looks up a language by name or alias.
         * @param {?} name Language name
         * @return {?} The language object if found, undefined otherwise.
         */
        HighlightLibrary.prototype.getLanguage = function (name) { };
        /**
         * Add line numbers to code element
         * @param {?} el Code element
         * @return {?}
         */
        HighlightLibrary.prototype.lineNumbersBlock = function (el) { };
    }
    /**
     * @record
     */
    function HighlightConfig() { }
    if (false) {
        /**
         * tabReplace: a string used to replace TAB characters in indentation.
         * @type {?|undefined}
         */
        HighlightConfig.prototype.tabReplace;
        /**
         * useBR: a flag to generate <br> tags instead of new-line characters in the output, useful when code is marked up using a non-<pre> container.
         * @type {?|undefined}
         */
        HighlightConfig.prototype.useBR;
        /**
         * classPrefix: a string prefix added before class names in the generated markup, used for backwards compatibility with stylesheets.
         * @type {?|undefined}
         */
        HighlightConfig.prototype.classPrefix;
        /**
         * languages: an array of language names and aliases restricting auto detection to only these languages.
         * @type {?|undefined}
         */
        HighlightConfig.prototype.languages;
    }
    /**
     * @record
     */
    function HighlightResult() { }
    if (false) {
        /** @type {?|undefined} */
        HighlightResult.prototype.language;
        /** @type {?|undefined} */
        HighlightResult.prototype.r;
        /** @type {?|undefined} */
        HighlightResult.prototype.second_best;
        /** @type {?|undefined} */
        HighlightResult.prototype.top;
        /** @type {?|undefined} */
        HighlightResult.prototype.value;
    }
    /**
     * @record
     */
    function HighlightOptions() { }
    if (false) {
        /** @type {?|undefined} */
        HighlightOptions.prototype.config;
        /** @type {?|undefined} */
        HighlightOptions.prototype.lineNumbers;
    }
    /** @type {?} */
    var HIGHLIGHT_OPTIONS = new core.InjectionToken('HIGHLIGHT_OPTIONS');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var HighlightLoader = /** @class */ (function () {
        function HighlightLoader(doc, platformId, _options) {
            var _this = this;
            this._options = _options;
            // Stream that emits when hljs library is loaded and ready to use
            this._ready = new rxjs.BehaviorSubject(null);
            this.ready = this._ready.asObservable().pipe(operators.filter((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return !!hljs; })), operators.take(1));
            // Check if hljs is already available
            if (common.isPlatformBrowser(platformId) && doc.defaultView.hljs) {
                this._ready.next(doc.defaultView.hljs);
            }
            else {
                // Load hljs library
                this._loadHighlightLibrary().pipe(operators.switchMap((/**
                 * @param {?} hljs
                 * @return {?}
                 */
                function (hljs) {
                    if (_this._options.lineNumbers) {
                        // Make hljs available on window object (required for the line numbers library)
                        doc.defaultView.hljs = hljs;
                        // Load line numbers library
                        return _this._loadLineNumbers().pipe(operators.tap((/**
                         * @return {?}
                         */
                        function () { return _this._ready.next(hljs); })));
                    }
                    else {
                        _this._ready.next(hljs);
                        return rxjs.EMPTY;
                    }
                })), operators.catchError((/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) {
                    console.error('Unable to load hljs library', e);
                    return rxjs.EMPTY;
                }))).subscribe();
            }
        }
        /**
         * Lazy-Load highlight.js library
         */
        /**
         * Lazy-Load highlight.js library
         * @private
         * @return {?}
         */
        HighlightLoader.prototype._loadHighlightLibrary = /**
         * Lazy-Load highlight.js library
         * @private
         * @return {?}
         */
        function () {
            return this.importModule(import('highlight.js'));
        };
        /**
         * Lazy-Load highlight.js library
         */
        /**
         * Lazy-Load highlight.js library
         * @private
         * @return {?}
         */
        HighlightLoader.prototype._loadLineNumbers = /**
         * Lazy-Load highlight.js library
         * @private
         * @return {?}
         */
        function () {
            return this.importModule(import('highlightjs-line-numbers.js'));
        };
        /**
         * @private
         * @param {?} loader
         * @return {?}
         */
        HighlightLoader.prototype.importModule = /**
         * @private
         * @param {?} loader
         * @return {?}
         */
        function (loader) {
            return rxjs.from(loader).pipe(operators.filter((/**
             * @param {?} module
             * @return {?}
             */
            function (module) { return !!module && !!module.default; })), operators.map((/**
             * @param {?} module
             * @return {?}
             */
            function (module) { return module.default; })));
        };
        HighlightLoader.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        HighlightLoader.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] },
            { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [HIGHLIGHT_OPTIONS,] }] }
        ]; };
        /** @nocollapse */ HighlightLoader.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function HighlightLoader_Factory() { return new HighlightLoader(core.ɵɵinject(common.DOCUMENT), core.ɵɵinject(core.PLATFORM_ID), core.ɵɵinject(HIGHLIGHT_OPTIONS, 8)); }, token: HighlightLoader, providedIn: "root" });
        return HighlightLoader;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        HighlightLoader.prototype._ready;
        /** @type {?} */
        HighlightLoader.prototype.ready;
        /**
         * @type {?}
         * @private
         */
        HighlightLoader.prototype._options;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HighlightJS = /** @class */ (function () {
        function HighlightJS(_loader, options) {
            var _this = this;
            this._loader = _loader;
            // Load highlight.js library on init
            _loader.ready.pipe().subscribe((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) {
                _this._hljs = hljs;
                if (options && options.config) {
                    // Set global config if present
                    hljs.configure(options.config);
                    if (hljs.listLanguages().length < 1) {
                        console.error('[HighlightJS]: No languages were registered!');
                    }
                }
            }));
        }
        Object.defineProperty(HighlightJS.prototype, "hljs", {
            // A reference for hljs library
            get: 
            // A reference for hljs library
            /**
             * @return {?}
             */
            function () {
                return this._hljs;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Core highlighting function.
         * @param name Accepts a language name, or an alias
         * @param value A string with the code to highlight.
         * @param ignore_illegals When present and evaluates to a true value, forces highlighting to finish
         * even in case of detecting illegal syntax for the language instead of throwing an exception.
         * @param continuation An optional mode stack representing unfinished parsing.
         * When present, the function will restart parsing from this state instead of initializing a new one
         */
        /**
         * Core highlighting function.
         * @param {?} name Accepts a language name, or an alias
         * @param {?} value A string with the code to highlight.
         * @param {?} ignore_illegals When present and evaluates to a true value, forces highlighting to finish
         * even in case of detecting illegal syntax for the language instead of throwing an exception.
         * @param {?=} continuation An optional mode stack representing unfinished parsing.
         * When present, the function will restart parsing from this state instead of initializing a new one
         * @return {?}
         */
        HighlightJS.prototype.highlight = /**
         * Core highlighting function.
         * @param {?} name Accepts a language name, or an alias
         * @param {?} value A string with the code to highlight.
         * @param {?} ignore_illegals When present and evaluates to a true value, forces highlighting to finish
         * even in case of detecting illegal syntax for the language instead of throwing an exception.
         * @param {?=} continuation An optional mode stack representing unfinished parsing.
         * When present, the function will restart parsing from this state instead of initializing a new one
         * @return {?}
         */
        function (name, value, ignore_illegals, continuation) {
            return this._loader.ready.pipe(operators.map((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.highlight(name, value, ignore_illegals, continuation); })));
        };
        /**
         * Highlighting with language detection.
         * @param value Accepts a string with the code to highlight
         * @param languageSubset An optional array of language names and aliases restricting detection to only those languages.
         * The subset can also be set with configure, but the local parameter overrides the option if set.
         */
        /**
         * Highlighting with language detection.
         * @param {?} value Accepts a string with the code to highlight
         * @param {?} languageSubset An optional array of language names and aliases restricting detection to only those languages.
         * The subset can also be set with configure, but the local parameter overrides the option if set.
         * @return {?}
         */
        HighlightJS.prototype.highlightAuto = /**
         * Highlighting with language detection.
         * @param {?} value Accepts a string with the code to highlight
         * @param {?} languageSubset An optional array of language names and aliases restricting detection to only those languages.
         * The subset can also be set with configure, but the local parameter overrides the option if set.
         * @return {?}
         */
        function (value, languageSubset) {
            return this._loader.ready.pipe(operators.map((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.highlightAuto(value, languageSubset); })));
        };
        /**
         * Post-processing of the highlighted markup.
         * Currently consists of replacing indentation TAB characters and using <br> tags instead of new-line characters.
         * Options are set globally with configure.
         * @param value Accepts a string with the highlighted markup
         */
        /**
         * Post-processing of the highlighted markup.
         * Currently consists of replacing indentation TAB characters and using <br> tags instead of new-line characters.
         * Options are set globally with configure.
         * @param {?} value Accepts a string with the highlighted markup
         * @return {?}
         */
        HighlightJS.prototype.fixMarkup = /**
         * Post-processing of the highlighted markup.
         * Currently consists of replacing indentation TAB characters and using <br> tags instead of new-line characters.
         * Options are set globally with configure.
         * @param {?} value Accepts a string with the highlighted markup
         * @return {?}
         */
        function (value) {
            return this._loader.ready.pipe(operators.map((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.fixMarkup(value); })));
        };
        /**
         * Applies highlighting to a DOM node containing code.
         * The function uses language detection by default but you can specify the language in the class attribute of the DOM node.
         * See the class reference for all available language names and aliases.
         * @param block The element to apply highlight on.
         */
        /**
         * Applies highlighting to a DOM node containing code.
         * The function uses language detection by default but you can specify the language in the class attribute of the DOM node.
         * See the class reference for all available language names and aliases.
         * @param {?} block The element to apply highlight on.
         * @return {?}
         */
        HighlightJS.prototype.highlightBlock = /**
         * Applies highlighting to a DOM node containing code.
         * The function uses language detection by default but you can specify the language in the class attribute of the DOM node.
         * See the class reference for all available language names and aliases.
         * @param {?} block The element to apply highlight on.
         * @return {?}
         */
        function (block) {
            return this._loader.ready.pipe(operators.map((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.highlightBlock(block); })));
        };
        /**
         * Configures global options:
         * @param config HighlightJs configuration argument
         */
        /**
         * Configures global options:
         * @param {?} config HighlightJs configuration argument
         * @return {?}
         */
        HighlightJS.prototype.configure = /**
         * Configures global options:
         * @param {?} config HighlightJs configuration argument
         * @return {?}
         */
        function (config) {
            return this._loader.ready.pipe(operators.map((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.configure(config); })));
        };
        /**
         * Applies highlighting to all <pre><code>..</code></pre> blocks on a page.
         */
        /**
         * Applies highlighting to all <pre><code>..</code></pre> blocks on a page.
         * @return {?}
         */
        HighlightJS.prototype.initHighlighting = /**
         * Applies highlighting to all <pre><code>..</code></pre> blocks on a page.
         * @return {?}
         */
        function () {
            return this._loader.ready.pipe(operators.map((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.initHighlighting(); })));
        };
        /**
         * Adds new language to the library under the specified name. Used mostly internally.
         * @param name A string with the name of the language being registered
         * @param language A function that returns an object which represents the language definition.
         * The function is passed the hljs object to be able to use common regular expressions defined within it.
         */
        /**
         * Adds new language to the library under the specified name. Used mostly internally.
         * @param {?} name A string with the name of the language being registered
         * @param {?} language A function that returns an object which represents the language definition.
         * The function is passed the hljs object to be able to use common regular expressions defined within it.
         * @return {?}
         */
        HighlightJS.prototype.registerLanguage = /**
         * Adds new language to the library under the specified name. Used mostly internally.
         * @param {?} name A string with the name of the language being registered
         * @param {?} language A function that returns an object which represents the language definition.
         * The function is passed the hljs object to be able to use common regular expressions defined within it.
         * @return {?}
         */
        function (name, language) {
            return this._loader.ready.pipe(operators.map((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.registerLanguage(name, language); })));
        };
        /**
         * @return The languages names list.
         */
        /**
         * @return {?} The languages names list.
         */
        HighlightJS.prototype.listLanguages = /**
         * @return {?} The languages names list.
         */
        function () {
            return this._loader.ready.pipe(operators.map((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.listLanguages(); })));
        };
        /**
         * Looks up a language by name or alias.
         * @param name Language name
         * @return The language object if found, undefined otherwise.
         */
        /**
         * Looks up a language by name or alias.
         * @param {?} name Language name
         * @return {?} The language object if found, undefined otherwise.
         */
        HighlightJS.prototype.getLanguage = /**
         * Looks up a language by name or alias.
         * @param {?} name Language name
         * @return {?} The language object if found, undefined otherwise.
         */
        function (name) {
            return this._loader.ready.pipe(operators.map((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.getLanguage(name); })));
        };
        /**
         * Display line numbers
         * @param el Code element
         */
        /**
         * Display line numbers
         * @param {?} el Code element
         * @return {?}
         */
        HighlightJS.prototype.lineNumbersBlock = /**
         * Display line numbers
         * @param {?} el Code element
         * @return {?}
         */
        function (el) {
            return this._loader.ready.pipe(operators.filter((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return !!hljs.lineNumbersBlock; })), operators.tap((/**
             * @param {?} hljs
             * @return {?}
             */
            function (hljs) { return hljs.lineNumbersBlock(el); })), operators.map((/**
             * @return {?}
             */
            function () { return null; })));
        };
        HighlightJS.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        HighlightJS.ctorParameters = function () { return [
            { type: HighlightLoader },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [HIGHLIGHT_OPTIONS,] }] }
        ]; };
        /** @nocollapse */ HighlightJS.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function HighlightJS_Factory() { return new HighlightJS(core.ɵɵinject(HighlightLoader), core.ɵɵinject(HIGHLIGHT_OPTIONS, 8)); }, token: HighlightJS, providedIn: "root" });
        return HighlightJS;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        HighlightJS.prototype._hljs;
        /**
         * @type {?}
         * @private
         */
        HighlightJS.prototype._loader;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Highlight = /** @class */ (function () {
        function Highlight(el, _hljs, _options) {
            this._hljs = _hljs;
            this._options = _options;
            // Stream that emits when code string is highlighted
            this.highlighted = new core.EventEmitter();
            this._nativeElement = el.nativeElement;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        Highlight.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes.code &&
                changes.code.currentValue &&
                changes.code.currentValue !== changes.code.previousValue) {
                this.highlightElement(this.code, this.languages);
            }
        };
        /**
         * Highlighting with language detection and fix markup.
         * @param code Accepts a string with the code to highlight
         * @param languages An optional array of language names and aliases restricting detection to only those languages.
         * The subset can also be set with configure, but the local parameter overrides the option if set.
         */
        /**
         * Highlighting with language detection and fix markup.
         * @param {?} code Accepts a string with the code to highlight
         * @param {?=} languages An optional array of language names and aliases restricting detection to only those languages.
         * The subset can also be set with configure, but the local parameter overrides the option if set.
         * @return {?}
         */
        Highlight.prototype.highlightElement = /**
         * Highlighting with language detection and fix markup.
         * @param {?} code Accepts a string with the code to highlight
         * @param {?=} languages An optional array of language names and aliases restricting detection to only those languages.
         * The subset can also be set with configure, but the local parameter overrides the option if set.
         * @return {?}
         */
        function (code, languages) {
            var _this = this;
            // Set code text before highlighting
            this.setCode(code);
            this._hljs.highlightAuto(code, languages).subscribe((/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                // Set highlighted code
                _this.setCode(res.value);
                // Check if user want to show line numbers
                if (_this.lineNumbers && _this._options.lineNumbers) {
                    rxjs.animationFrameScheduler.schedule((/**
                     * @return {?}
                     */
                    function () {
                        return _this._hljs.lineNumbersBlock(_this._nativeElement).subscribe();
                    }));
                }
                // Forward highlight response to the highlighted output
                _this.highlighted.emit(res);
            }));
        };
        /**
         * @private
         * @param {?} content
         * @return {?}
         */
        Highlight.prototype.setCode = /**
         * @private
         * @param {?} content
         * @return {?}
         */
        function (content) {
            var _this = this;
            rxjs.animationFrameScheduler.schedule((/**
             * @return {?}
             */
            function () { return _this._nativeElement.innerHTML = content; }));
        };
        Highlight.decorators = [
            { type: core.Directive, args: [{
                        host: {
                            '[class.hljs]': 'true'
                        },
                        selector: '[highlight]'
                    },] }
        ];
        /** @nocollapse */
        Highlight.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: HighlightJS },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [HIGHLIGHT_OPTIONS,] }] }
        ]; };
        Highlight.propDecorators = {
            code: [{ type: core.Input, args: ['highlight',] }],
            languages: [{ type: core.Input }],
            lineNumbers: [{ type: core.Input }],
            highlighted: [{ type: core.Output }]
        };
        return Highlight;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        Highlight.prototype._nativeElement;
        /** @type {?} */
        Highlight.prototype.code;
        /** @type {?} */
        Highlight.prototype.languages;
        /** @type {?} */
        Highlight.prototype.lineNumbers;
        /** @type {?} */
        Highlight.prototype.highlighted;
        /**
         * @type {?}
         * @private
         */
        Highlight.prototype._hljs;
        /**
         * @type {?}
         * @private
         */
        Highlight.prototype._options;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var HighlightModule = /** @class */ (function () {
        function HighlightModule() {
        }
        HighlightModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [Highlight],
                        exports: [Highlight]
                    },] }
        ];
        return HighlightModule;
    }());

    exports.HIGHLIGHT_OPTIONS = HIGHLIGHT_OPTIONS;
    exports.Highlight = Highlight;
    exports.HighlightJS = HighlightJS;
    exports.HighlightLoader = HighlightLoader;
    exports.HighlightModule = HighlightModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-highlightjs.umd.js.map
